var express = require('express');
var path = require('path');
var favicon = require('serve-favicon');
var logger = require('morgan');
var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');
var SSE = require('express-sse');
var request = require('request');

var fs    = require('fs');
var nconf = require('nconf');

var index = require('./routes/index');
var index2 = require('./routes/index2');
var users = require('./routes/users');
var api = require('./routes/api');

var app = express();

var sse = new SSE();

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'ejs');

// uncomment after placing your favicon in /public
//app.use(favicon(path.join(__dirname, 'public', 'favicon.ico')));
app.use(logger('dev'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

app.get('/stream', sse.init);

app.use('/', index);
app.use('/index2', index2);
app.use('/users', users);
app.use('/api', api);

var i = 0

setInterval(function() {
  nconf.file({ file:'config.json' });
  numberOfServers = nconf.get('configuration').servers.length;
  message = {};
  message.server = i;
  ip = nconf.get('configuration').servers[i].ip;
  port = nconf.get('configuration').servers[i].port;
  request('http://' + ip + ':' + port + '/api/stats', function(err, response, body) {
    message.body = body;
    sse.send(message);
    console.log(message);
  });
  i++;
  if(i >= numberOfServers) {
    i = 0;
  }
}, 5000);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  var err = new Error('Not Found');
  err.status = 404;
  next(err);
});

// error handler
app.use(function(err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});

module.exports = app;
